function createTimer(_args) {
	var timerView = Ti.UI.createView({
		backgroundColor:'#000',
		top:60,
		bottom:0,
		left:0,
		right:0
	});
		
	var m = _args.min;
	var s = _args.sec;
	m_set = m;
	s_set = s;
	var active = 0;

	var countDown =  function(m, s, fn_tick, fn_end ) {
		return {
			total_sec:m*60+s,
			timer:this.timer,
			set: function(m,s) {
				var sDisp = parseInt(s);
	  		if (s<10) {
	  			var sDisp = "0"+parseInt(s);
	  		}
	  		var mDisp = parseInt(m);
	  		if (m<10) {
	  			var mDisp = "0"+parseInt(m);
	  		}
				this.total_sec = parseInt(m)*60+parseInt(s);
				display_lbl.text = mDisp+" : "+sDisp;
				this.time = {m:m,s:s};
				return this;
			},
			start: function() {			
				var self = this;
				var full_time = self.total_sec;
				this.timer = setInterval( function() {
					if (self.total_sec) {
					  if(self.total_sec == 0) {
						  self.total_sec = full_time;
						}
						self.total_sec--;
						self.time = { m : parseInt(self.total_sec/60), s: (self.total_sec%60) };					
						fn_tick();
					}	else {
						self.stop();
						fn_end();
					}
				}, 1000 );
				return this;
			},
			stop: function() {
				active = 0;
				clearInterval(this.timer);
				this.time = {m:0,s:0};
				this.total_sec = 0;
				display_lbl.text = "00 : 00";
				return this;
			}
		};
	};

	var my_timer = new countDown(m, s, 
		function() {
			var sDisp = my_timer.time.s;
	 		if (my_timer.time.s<10) {
	 			var sDisp = "0"+parseInt(my_timer.time.s);
	 		}
	 		var mDisp = my_timer.time.m;
	 		if (my_timer.time.m<10) {
	 			var mDisp = "0"+parseInt(my_timer.time.m);
	 		}
			display_lbl.text = mDisp+" : "+sDisp;
		},
		function() {
			//alert("The time is up!");
		}
	);

	var containerView = Ti.UI.createView({
		height:300,
		width:320,
		backgroundColor:'#000'
	});
	var display_lbl =  Ti.UI.createLabel({
		text: m+" : "+s,
		id:'LblTimer',
	//	className:'lbl_timer',
		height:80,
		width:320,
		top:0,//-180,
		left:0,
		color:'#fff',
		borderRadius:10,
		backgroundColor:'#000',
		font:{
			fontSize:70,
			fontWeight:'bold'
		},
		textAlign:'center'
	});

	my_timer.set(m,s);

	var btnView = Ti.UI.createView({
		top:110,
		height:180,
		width:320,
		backgroundImage:''
	});
	var set_btn = Ti.UI.createButton({
		id:'BtnSet',
	//	className:'btn_set',
		title:'Set',
		width:70,
		height:40,
		top:70,
		left:35,
		font:{
			fontSize:15,
			fontWeight:'bold'
		},
		textAlign:'center'
	});

	var start_btn = Ti.UI.createButton({
		id:'BtnStr',
	//	className:'btn_start',
		title:'Start',
		width:70,
		height:40,
		top:70,
		left:125,	
		font:{
			fontSize:15,
			fontWeight:'bold'
		},
		textAlign:'center'
	});

	var stop_btn = Ti.UI.createButton({
		id:'BtnStop',
	//	className:'btn_stop',
		title:'Stop',
		width:70,
		height:40,
		top:70,
		left:215,	
		font:{
			fontSize:15,
			fontWeight:'bold'
		},
		textAlign:'center'
	});

	set_btn.addEventListener('click',function(){
		display_lbl.text = m_set+" : "+s_set;	
		my_timer.set(m_set,s_set);
	});

	stop_btn.addEventListener('click',function(){
		my_timer.stop();
	});

	start_btn.addEventListener('click',function(){
		//my_timer.set(m,s,r);
		if(!active) {
			active = 1;
			my_timer.start();			
		}
	});


	btnView.add(set_btn);
	btnView.add(start_btn);
	btnView.add(stop_btn);

	containerView.add(btnView);
	containerView.add(display_lbl);
	timerView.add(containerView);
	return timerView;
};

var win1 = Ti.UI.currentWindow;

var min = Titanium.UI.createTextField({
	top:30,
	width:300,
	height:45,
	borderStyle:Titanium.UI.INPUT_BORDERSTYLE_ROUNDED,
	color:'#000000',
	hintText: 'Minutes'
});
var sec = Titanium.UI.createTextField({
	top:80,
	width:300,
	hintText:'Seconds',
	height:45,
	borderStyle:Titanium.UI.INPUT_BORDERSTYLE_ROUNDED,
	color:'#000000'
});

launchButton = Ti.UI.createButton({
	title:'Launch Timer',
	top:150,
	width:300,
	height:40
});


launchButton.addEventListener('click', function(_e) {
	min.blur();
	sec.blur();
	var winTimer = Ti.UI.createWindow({
  	'title': 'Timer'
  });    
  var _args = {
  	min:min.value,
  	sec:sec.value,
  }; 
	var timeView = createTimer(_args);
  winTimer.add(timeView);
	
  Ti.UI.currentTab.open(winTimer,{animated:true});
	
});

win1.add(min);
win1.add(sec);
win1.add(launchButton);
